<template>
  <figure class="module module-video mb-0 mobile-fullwidth" :class="{ 'pb-0' : data.removePaddingBottom }">
    <div class="row">
      <div class="col-12 col-lg-10 offset-lg-1">
        <div class="responsive-iframe">
          <client-only v-if="consentGiven">
              <youtube
                  :video-id="videoUrl"
                  :player-width="1080"
                  :player-height="675"
                  :player-vars="{
                      controls: 1,
                      showinfo: 0,
                      autohide: 1,
                      modestbranding: 1,
                      enablejsapi: 1,
                      iv_load_policy: 3,
                  }"
                  @ready="ready"
                  @playing="playing"
                  @paused="paused"
              ></youtube>
          </client-only>
          <div
              ref="ytOverlay"
              class="youtube-overlay"
              :style="overlayStyles"
              :class="{ play: play }"
              @click="clickListener"
          >
              <atom-image
                  v-if="data.image"
                  ref="thumbnail"
                  class="video-thumbnail"
                  ratio="16x9"
                  :image="data.image"
              ></atom-image>
              <div
                  ref="playBtn"
                  class="play-button"
                  :class="{ 'play-button-anim': play }"
              >
                  <span class="icon-play"></span>
              </div>
          </div>
        </div>
      </div>
    </div>
  </figure>
</template>

<script>
export default {
    name: 'VideoModule',
    props: {
        data: {
          type:Object,
          default: () => {},
        }
    },
    data() {
        return {
            play: false,
        };
    },
    computed: {
        videoUrl() {
            return this.$youtube.getIdFromURL(this.data.url);
        },
        overlayStyles() {
            return this.play ? 'pointer-events: none;' : 'pointer-events: all;';
        },
        consentGiven() {
            if (
                process.client &&
                window.Cookiebot &&
                window.Cookiebot.consent
            ) {
                return window.Cookiebot.consent.marketing;
            }
            return false;
        },
        image() {
          return this.data.image;
        }
    },
    methods: {
        ready(event) {
            this.player = event.target;
        },
        playing() {
            this.play = true;
        },
        paused() {
            this.play = false;
        },
        clickListener() {
            if (this.consentGiven) {
                this.player.playVideo();
                this.play = !this.play;
            } else {
                window.open(this.data.url, '_blank').focus();
            }
        },
    },
};
</script>

<style lang="scss" scoped>
.module-video {
    flex: 1 1 auto;

    .responsive-iframe {
        position: relative;
        padding-bottom: 56.25%;
        padding-top: 0;
        height: 0;
        overflow: hidden;

        &::v-deep iframe {
            position: absolute;
            top: 0;
            left: 0;
            width: 100%;
            height: 100%;
        }

        .youtube-overlay {
            display: block;
            position: relative;
            height: 0;
            padding-bottom: 56.25%;

            &.play {
                .video-thumbnail {
                    opacity: 0;
                    visibility: hidden;
                    transition: opacity ease 0.35s, visibility ease 0.1s 0.35s;
                }
            }

            .video-thumbnail {
                position: absolute;
                left: 0;
                top: 0;
                right: 0;
                bottom: 0;
                opacity: 1;
                visibility: visible;
                transition: opacity ease 0.35s 0.1s, visibility ease 0.1s;
            }

            .play-button {
                width: 64px;
                height: 64px;
                border-radius: 50%;
                background-color: rgb(255,255,255, 0.8);
                position: absolute;
                margin: auto;
                top: 0;
                bottom: 0;
                left: 0;
                right: 0;
                transition: background-color 300ms linear, opacity 500ms linear,
                    transform 350ms ease-in;
                cursor: pointer;
                pointer-events: all;

                @include media-breakpoint-up(md) {
                    width: 132px;
                    height: 132px;
                }

                &:hover {
                    background-color: rgb(255,255,255, 1);
                    transform: scale(1.01);
                }

                &.play-button-anim,
                &:hover.play-button-anim {
                    opacity: 0 !important;
                    pointer-events: none;
                    transform: scale(0.9);
                }

                .icon-play {
                    position: absolute;
                    margin: auto;
                    top: 0;
                    bottom: 0;
                    left: 0;
                    right: -8%;
                    width: 0;
                    height: 0;
                    border-style: solid;
                    border-width: 18px 0 18px 30px;
                    border-color: transparent transparent transparent $primary;

                    @include media-breakpoint-up(md) {
                        border-width: 25px 0 25px 40px;
                    }
                }
            }
        }
    }

    .video-caption {
        font-size: 14px;
        margin-top: 0.5rem;

        @include media-breakpoint-up(md) {
            font-size: 16px;
            max-width: 80%;
        }
    }
}
</style>
